package eap.freeciv;

import java.io.*;

/**************************************************************************
*
**************************************************************************/
public class BitStringField extends SimpleField {


/**************************************************************************
*
**************************************************************************/
public void readValue(Packet packet, PacketSource source) throws IOException {

    int nbits = source.readByte();
    
  //  System.out.println("reading bit string nbits="+nbits);
    
    StringBuffer buffer=new StringBuffer();
    
    int value=0;
    for(int i=0; i<nbits; ++i) {
        int bit = i%8;

        if(bit==0) value = source.readByte();
        
      //  if(bit==0)System.out.println("reading bit string value "+value);
        


        if((value & (1<<bit) ) != 0) buffer.append('1');
        else                         buffer.append('0');
        
//System.out.println("    "+bit+" = "+ (value & (1<<bit) )+" "+buffer );
    }
        

    packet.setValue(name, buffer.toString() );


} // end of read method

/**************************************************************************
*
**************************************************************************/
public void writeValue(Object object, OutputStream out) throws IOException {

    String string = object.toString();

  //  System.out.println("writing bit string "+string);

    /**********************
    * write the bit count *
    **********************/
    int nbits = string.length();
    out.write(nbits);

    /*****************
    * write the bits *
    *****************/
    int value=0;
    for(int i=0; i<nbits; ++i) {
        int bit = i%8;
        
        if(string.charAt(i) != '0') {
            value |= (1<<bit);
        }

        if(bit==7 || i==nbits-1) {
            out.write(value);
            value=0;
        }
      //  if(bit==7 || i==nbits-1)System.out.println("writing bit string value "+value);
    } // end of loop over bits



} // end of writeValue method


/**************************************************************************
*
**************************************************************************/
public int getValueSize(Packet packet) {

    String string = packet.getValue(name).toString();
    return 1+(string.length()+7)/8;
}


} // end of BitStringField inner class
