package eap.freeciv;

import java.io.*;

/**************************************************************************
*
**************************************************************************/
public class BooleanField extends SimpleField {

int nbytes;

/**************************************************************************
*
**************************************************************************/
public BooleanField(int nbytes) {
    this.nbytes = nbytes;
}



/**************************************************************************
*
**************************************************************************/
public void readValue(Packet packet, PacketSource source) throws IOException {

    long value=0l;

    for(int i=0; i<nbytes; ++i) {
        value <<=8;
        value |= source.readByte();
    }

    packet.setValue(name, new Boolean(value!=0) );


} // end of read method

/**************************************************************************
*
**************************************************************************/
public void writeValue(Object object, OutputStream out) throws IOException {

    if(!(object instanceof Boolean)) {
        throw new IOException(name+" = "+object+" is not a boolean\n");
    }

    boolean value = ((Boolean)object).booleanValue();
    
    /**********************
    * write padding bytes *
    **********************/
    for(int i=0; i< nbytes-1; ++i) out.write(0);
    
    if(value) out.write(1);
    else      out.write(0);

} // end of writeValue method 

/****************************************************************************
*
****************************************************************************/
public int getValueSize(Packet packet) {

    return nbytes;

} // end of getValueSize method

} // end of UnsignedIntegerField inner class
