package eap.freeciv;

import java.util.*;

public class Player implements PacketListener {

int id;
Map units;
Map cities;

Packet[][] map;

/****************************************************************************
*
****************************************************************************/
public Player() {

    map=null;

    units  = new HashMap();
    cities = new HashMap();
    
    id=-1;

} // end of constructor

/****************************************************************************
* update the game state
****************************************************************************/
public void receivePacket(Packet packet) {

    String name = packet.getName();

    if(name.equals("MAP_INFO")) {
        /*********************
        * initialize the map *
        *********************/
        if(map==null) {
            map = new Packet[packet.intValue("ysize")][packet.intValue("xsize")];
        } else {
            if(packet.intValue("ysize") != map.length ||
               packet.intValue("xsize") != map[0].length ) {
                System.err.println("Map dimensions changed!");
                System.exit(1);
            }
        }

    } else if(name.equals("TILE_INFO")) {
        /*****************
        * update the map *
        *****************/
        map[packet.intValue("y")][packet.intValue("x")] = packet;

    } else if(name.equals("UNIT_INFO")) {
        /***********************
        * update the unit list *
        ***********************/
        units.put(new Integer(packet.intValue("id")), packet);

    } else if(name.equals("CITY_INFO")) {
        cities.put(new Integer(packet.intValue("id")), packet);

    } else if(name.equals("GAME_INFO")) {
        id = packet.intValue("player_idx");
    }

    


} // end of receive packet mathod

} // end of Player class
