package eap.freeciv;

import java.io.*;

/**************************************************************************
*
**************************************************************************/
public class StringField extends SimpleField {

/**************************************************************************
*
**************************************************************************/
public void readValue(Packet packet, PacketSource source) throws IOException {

    StringBuffer buffer = new StringBuffer();
    
//System.out.println("About to read string "+name+" remaining="+source.remainingBytes());

    /***************************
    * read up to the next NULL *
    ***************************/
    int value;
    while((value=source.readByte()) != 0 ) {

        buffer.append((char)value);

    }
    
  //  System.out.println("read string "+buffer);
    
    packet.setValue(name, buffer.toString() );

} // end of read method

/**************************************************************************
*
**************************************************************************/
public void writeValue(Object object, OutputStream out) throws IOException {


    String string = object.toString();


  // System.out.println("writing string length="+string.length()+" "+name+" = |"+string+"|");

    /***********************
    * write the characters *
    ***********************/
    for(int i=0; i<string.length(); ++i) {
    
  //  System.out.println(i+" "+(int)string.charAt(i));
        out.write(string.charAt(i));
    }
    
    /******************
    * null terminator *
    ******************/
    out.write(0);

} // end of writeValue method

/**************************************************************************
*
**************************************************************************/
public int getValueSize(Packet packet) {
    
    String string = packet.getValue(name).toString();
    
    return string.length()+1;
}


} // end of UnsignedIntegerField inner class
