package eap.freeciv;

import java.io.*;

/**************************************************************************
*
**************************************************************************/
public class UnsignedIntField extends SimpleField {

int nbytes;

/**************************************************************************
*
**************************************************************************/
public UnsignedIntField(int nbytes) {
    this.nbytes = nbytes;
}


/**************************************************************************
*
**************************************************************************/
public void readValue(Packet packet, PacketSource source) throws IOException {

    long value=0l;

    for(int i=0; i<nbytes; ++i) {
        value <<=8;
        value |= source.readByte();
    }
    
   // System.out.println("    reading uint "+name+" = "+value);

    if(scale!= 1.0) packet.setValue(name, new Double(scale*(double)value) );
    else            packet.setValue(name, new Long(value) );

} // end of read method

/**************************************************************************
*
**************************************************************************/
public void writeValue(Object object, OutputStream out) throws IOException {

    /********************************
    * get the value from the packet *
    ********************************/
    long value;
    try {
        Number number = (Number)object;

        if(scale==1.0) value = number.longValue();
        else           value = (long)(number.doubleValue()/scale);
    } catch(ClassCastException e) {
        throw new IOException(name+" = "+object+" is not a number\n");
    }

    /******************
    * write the bytes *
    ******************/
//System.out.println("writing unsigned byte value="+value);
    for(int i=nbytes-1; i>=0; --i) {
    
//System.out.println("writing unsigned byte "+i+" "+((int)((value >> (i*8)) & 255)) );
        out.write((int)((value >> (i*8)) & 255));
    }

} // end of writeValue method


/****************************************************************************
*
****************************************************************************/
public int getValueSize(Packet packet) {

    return nbytes;

} // end of getValueSize method

} // end of UnsignedIntegerField inner class
