package eap.freeciv;

import java.io.*;

/**************************************************************************
*
**************************************************************************/
public class CityMapField extends SimpleField {


/**************************************************************************
*
**************************************************************************/
public void readValue(Packet packet, PacketSource source) throws IOException {

    CityMap map = new CityMap();
    map.read(source);
    
    packet.setValue(name, map);


} // end of read method

/**************************************************************************
*
**************************************************************************/
public void writeValue(Object object, OutputStream out) throws IOException {

    if(!(object instanceof CityMap)) {
        throw new IOException(name+" = "+object+" is not a city map\n");
    }

    CityMap map = (CityMap)object;
    map.write(out);

} // end of read method

/**************************************************************************
*
**************************************************************************/
public int getValueSize(Packet packet) {

    CityMap map = (CityMap)packet.getValue(name);
    return map.size();
} // end of getValueSize method

} // end of UnsignedIntegerField inner class
