package eap.freeciv;

import java.io.*;
import java.net.*;

public class PassThrough {

Client client;
Server server;

/****************************************************************************
*
****************************************************************************/
public PassThrough(int server_port, String host, int client_port) 
       throws UnknownHostException, IOException {

    client = new Client();
    client.connectToServer(host, client_port);

    server = new Server(server_port);
    server.listenForClient();

    /***********************************************
    * connect the client and server to one another *
    ***********************************************/
    client.getConnection().addPacketListener(server);
    server.getConnection().addPacketListener(client);


} // end of constructor

/****************************************************************************
*
****************************************************************************/
public void beginListening() {

    client.getConnection().beginListening();
    server.getConnection().beginListening();
}

/****************************************************************************
*
****************************************************************************/
public Client getClient() { return client; }
public Server getServer() { return server; }

/****************************************************************************
*
****************************************************************************/
public static void main(String[] args) throws Exception {

    PassThrough pass = new PassThrough(4444,"localhost", 5555);

    pass.getClient().getConnection().addPacketListener(new PacketDumper("From Server"));
    pass.getServer().getConnection().addPacketListener(new PacketDumper("From Client"));
    
    Player player = new Player();
    pass.getClient().getConnection().addPacketListener(player);

    pass.beginListening();

} // end of main method
} // end of PassThrough class
