package eap.freeciv;

import java.io.*;
import java.net.*;
import java.util.*;

public class Server implements PacketListener {

ServerSocket server_socket;
List connections;


/****************************************************************************
*
****************************************************************************/
public Server(int port) throws IOException {

    server_socket = new ServerSocket(port);
    connections = new ArrayList();
} // end of constructor

/****************************************************************************
*
****************************************************************************/
public int getClientCount() { return connections.size(); }

/****************************************************************************
* return the connection to a given client
****************************************************************************/
public PacketConnection getConnection(int index) {

    return (PacketConnection)connections.get(index);

} // end of getConnection method

/****************************************************************************
* return the connection to a given client
****************************************************************************/
public PacketConnection getConnection() { return getConnection(0); }

/****************************************************************************
*
****************************************************************************/
public void listenForClient() throws IOException {

    Socket socket = server_socket.accept();
    
    PacketConnection connection = new PacketConnection(socket);
    connections.add(connection);

} // end of listenForClient method

/****************************************************************************
* broadcast the given packet to all the clients
****************************************************************************/
public void receivePacket(Packet packet) {

    for(Iterator it = connections.iterator(); it.hasNext(); ) {
        PacketConnection connection = (PacketConnection)it.next();

        try { connection.sendPacket(packet); }
        catch(IOException e) {
            System.err.println("Server could not send packet");
            System.err.println(e);
            System.exit(1);
        }
    }


} // end of receivePacket method

} // end of Server class