package eap.freeciv;

import java.io.*;

/******************************************************************************
* This is a special data structure used in the Freeciv packets.
******************************************************************************/
public class WorkList {

boolean is_valid;
String name;


int[] flags;
int[] ids;


/************************************************************************
*
************************************************************************/
public void read(PacketSource source) throws IOException {


    is_valid = (source.readByte() != 0);
    if(is_valid) {

        /*************************
        * read the worklist name *
        *************************/
        StringBuffer buffer = new StringBuffer();

        int value;
        while((value=source.readByte()) != 0 ) {

            buffer.append((char)value);

        }

        name = buffer.toString();
//System.out.println("reading work list name=|"+name+"|");

        /******************
        * read the length *
        ******************/
        int length = source.readByte();
//System.out.println("reading work list length="+length);
        flags = new int[length];
        ids   = new int[length];
        for(int i=0; i<length; ++i) {
        
            flags[i] = source.readByte();
            ids[i]   = source.readByte();

          //  System.out.println("reading work list "+i+" flags="+flags[i]+" ids="+ids[i]);

        
        } // end of loop over list
    } // end if this is a valid work list
    
//System.out.println("done reading work list bytes left="+source.remainingBytes() );

} // end of read method


/************************************************************************
*
************************************************************************/
public void write(OutputStream out) throws IOException {

    if(is_valid) out.write(1);
    else         out.write(0);
    if(!is_valid) return;
    
    /*****************
    * write the name *
    *****************/
    for(int i=0; i< name.length(); ++i) {
        out.write(name.charAt(i));
    }
    out.write(0); // null terminator
    
    /*******************
    * write the length *
    *******************/
    out.write(flags.length);
    
    /*******************
    * write the values *
    *******************/
    for(int i=0; i<flags.length; ++i) {
        out.write(flags[i]);
        out.write(ids[i]);
    }

} // end of write method

/************************************************************************
*
************************************************************************/
public int size() {

    if(! is_valid) return 1;
    
    return 1 + name.length()+1 + 1 + flags.length*2;
} // end of size method

} // end of Worklist
